kernel - mlockall: Return EINVAL for invalid flags combinations.
[dragonfly.git] / UPDATING
1 # Updating Information for DragonFly users.
2 #
3 #
4 # This file should warn you of any pitfalls which you might need to work around
5 # when trying to update your DragonFly system.  The information below is
6 # in reverse-time order, with the latest information at the top.
7 #
8 # If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9 # mailing list with the details.
10
11 +-----------------------------------------------------------------------+
12 +         20100927                                                      +
13 +         UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD                   +
14 +-----------------------------------------------------------------------+
15
16 OpenSSL
17 ========
18
19 OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
20 This shouldn't break any 3rd-party software, but you'll need to recompile your
21 3rd-party software if you want it to link against the new version of OpenSSL.
22
23 Loader
24 =======
25
26 A new loader (dloader) has been added which better handles booting from
27 multiple kernel/module versions.
28
29 To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
30
31         cd /usr/src
32         make buildworld
33         make installworld
34         make upgrade
35         make buildkernel KERNCONF=<KERNELNAME>
36         make installkernel KERNCONF=<KERNELNAME>
37
38 Note that you must installworld and run the 'upgrade' target before
39 installing the new kernel.
40
41 BIND
42 =====
43
44 BIND has been removed from the base system.  The ldns and drill tools have 
45 been added for basic functionality.  Use 'drill' where you would normally 
46 use nslookup or dig, or install BIND from pkgsrc.  It's available as 
47 net/bind95, net/bind96, or net/bind97 as of this writing.
48
49 This only affects older systems upgrading to 2.8.  New 2.8+ installs 
50 include BIND as a pkgsrc package.
51
52 +-----------------------------------------------------------------------+
53 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
54 +                               GENERAL                                 +
55 +-----------------------------------------------------------------------+
56
57 Instructions on how to obtain and maintain DragonFly source code using git
58 are in the development(7) manual page.
59
60 To upgrade a DragonFly system from sources you run the following sequence:
61
62         cd /usr/src
63         make buildworld
64         make buildkernel KERNCONF=<KERNELNAME>
65         make installkernel KERNCONF=<KERNELNAME>
66         make installworld
67
68 You will also want to run the 'upgrade' target to upgrade your /etc and the
69 rest of your system.  The upgrade target is aware of stale files created by
70 older DragonFly installations and should delete them automatically.
71
72         make upgrade
73
74 See the build(7) manual page for further information.
75
76 Once you've done a full build of the world and kernel you can do incremental
77 upgrades of either by using the 'quickworld' and 'quickkernel' targets
78 instead of 'buildworld' and 'buildkernel'.  If you have any problems with
79 the quick targets, try updating your repo first, and then a full buildworld
80 and buildkernel as shown above, before asking for help.
81
82 +-----------------------------------------------------------------------+
83 +         UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1           +
84 +-----------------------------------------------------------------------+
85
86 In 2.1 kernel and modules has moved to boot directory.  For most cases
87 this is handled automatically by 'make upgrade'.  A few cases needs manual
88 intervention:
89
90  * When installing a kernel without first doing a make buildworld,
91    installworld and upgrade to the same DESTDIR as kernel:
92    make DESTDIR/boot directory and move kernel and modules into this boot
93    directory; also move kernel.old and modules.old.
94    Typical example is vkernel(7), use (no modules used):
95
96         cd /var/vkernel
97         mkdir boot
98         chflags noschg kernel
99         mv kernel kernel.old boot
100         chflags schg boot/kernel
101         
102  * When using a boot-only partition, /boot/loader.rc needs to be edited:
103    delete occurrences of '/boot/'.
104    These occurences can normally be deleted in any case, see loader(8).
105
106 +-----------------------------------------------------------------------+
107 +         UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9           +
108 +-----------------------------------------------------------------------+
109
110 In 1.9 major changes to the disk management infrastructure have taken
111 place.  make upgrade may not catch all of your disk devices in /dev,
112 so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
113 are all of your disk devices.  HOWEVER, from late 2.3 on we run devfs
114 and MAKEDEV no longer exists.
115
116 The biggest changes in 1.9 are:
117
118 (1) That whole-slice devices such as da0s1 no longer share the same device
119     id as partition c devices such as da0s1c.
120
121 (2) The whole-disk device (e.g. da0) is full raw access to the disk,
122     with no snooping or reserved sectors.  Consequently you cannot run
123     disklabel on this device.  Instead you must run disklabel on a
124     whole-slice device.
125
126 (3) The 'compatibility' partitions now use slice 0 in the device name,
127     so instead of da0a you must specify da0s0a.  Also, as per (1) above,
128     accessing the disklabel for the compatibility partitions must be
129     done via slice 0 (da0s0).
130
131 (4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
132     and CCD now run through the disk management layer and are assigned
133     real disk management devices.   VN and CCD in particular do not usually
134     use a MBR and disklabels must be accessed through the compatibility
135     slice 0.  Your /etc/ccd.conf file still specifies 'ccd0', though, you
136     don't name it 'ccd0s0' in the config file.
137
138 Generally speaking, you have to get used to running fdisk and disklabel on
139 the correctly specified device names.  A lot of the wiggle, such as running
140 disklabel on a partition, has been removed.
141
142 +-----------------------------------------------------------------------+
143 +         UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD         +
144 +-----------------------------------------------------------------------+
145
146 > Kerberos IV
147 -------------
148
149 Kerberos IV (eBones) was removed from the tree, please consider moving to
150 Kerberos 5 (Heimdal).
151
152 > Package Management System
153 ---------------------------
154
155 Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
156 management system.  The necessary tools to build and maintain packages
157 are provided in /usr/pkg/bin and /usr/pkg/sbin.  Make sure that these
158 directories are in your PATH variable.
159
160 In order to obtain a reasonably current snapshot of the pkgsrc tree, use
161 the tarball from NetBSD:
162
163         fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
164         cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
165
166 This tree can then be kept up to date with cvs update:
167
168         cd /usr/pkgsrc; cvs up
169
170 NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
171 build and install the pkgsrc bootstrap manually:
172
173         cd /usr/pkgsrc/bootstrap
174         ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
175
176 +-----------------------------------------------------------------------+
177 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
178 +         UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO               +
179 +         DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD)                       +
180 +-----------------------------------------------------------------------+
181
182 The compatibility shims for the build environment have been removed, you
183 have to update to DragonFly 1.2 release branch first.
184
185 The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
186 The existing configuration can be converted using /etc/pam.d/convert.sh.
187 Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
188 the pam_skey.so module was retired, you have to remove it manually from
189 your configuration, when you convert it.
190
191 > Required user and group IDs when upgrading from either FreeBSD or DragonFly
192 ---------------------
193
194 The following users may be missing from your password file.  Use vipw and
195 add any that are missing:
196
197 smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
198 _pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
199
200 The following groups may be missing from your group file.  Use vi /etc/group
201 and add any that are missing:
202
203 smmsp:*:25:
204 authpf:*:63:
205 _pflogd:*:64:
206
207
208 > Upgrading to DragonFly from FreeBSD
209 ---------------------
210
211 You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
212 FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
213 FreeBSD.  Note that the DragonFly buildworld target does not try to reuse
214 make depend information, it starts from scratch, so no pre-cleaning of the
215 object hierarchy is necessary.
216
217         # get the CVS repository (it is placed in /home/dcvs, 500MB).
218         # Please use the -h option and a mirror site to pull the 
219         # initial repository, but feel free to use the main repository
220         # machine to pull updates.
221         cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
222         # install the source from the CVS hierarchy (remove preexisting
223         # FreeBSD src first) (500MB)
224         cd /usr
225         rm -rf src
226         cvs -R -d /home/dcvs checkout -P src
227
228         # build it (500MB used in /usr/obj)
229         #
230         cd /usr/src
231         make buildworld
232         make buildkernel KERNCONF=<KERNELNAME>
233
234 Once you have built DragonFly you have to install it over FreeBSD.  Since
235 DragonFly does not track changes made by FreeBSD to its include file 
236 hierarchy and include file pollution can cause all sorts of unexpected
237 compilation issues to come up, it is best to wipe your include hierarchy
238 prior to installing DragonFly.  Note that you should not wipe any installed
239 FreeBSD header files or binaries until after you have successfully completed
240 the build steps above.
241
242         rm -rf /usr/include
243         mkdir /usr/include
244         make installkernel KERNCONF=<KERNELNAME>
245         make installworld
246
247 Then you need to upgrade your system.  DragonFly's 'make upgrade' target 
248 will unconditionally upgrade the /etc files that sysops do not usually
249 mess around with, such as the files in /etc/rc.d.  It will also remove any
250 obsolete files such as utilities and manpages that have been removed from
251 the system since the version you're coming from.  If you are unsure we 
252 recommend that you make a backup of at least your /etc before applying
253 this step.  Note that DragonFly's RC system is basically RCNG from
254 FreeBSD-5, but there are some differences in the contents of the RC files.
255
256         make upgrade
257
258 NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
259 Doing so might leave your system in an unusable state.
260
261 Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
262 /usr/bin, and /usr/lib, and remove any stale files that you find.  Please
263 report these files to the DragonFly developers so that they can be added to
264 the 'upgrade' target.
265